package cn.gygxzc.cloud.config.controller

import cn.gygxzc.cloud.config.model.ConfigProperty
import cn.gygxzc.cloud.config.service.IConfigPropService
import com.baomidou.mybatisplus.core.metadata.IPage
import io.swagger.annotations.Api
import io.swagger.annotations.ApiOperation
import org.springframework.beans.factory.annotation.Autowired
import org.springframework.web.bind.annotation.*

/**
 * @author tuonina
 * @createTime 2019/4/12
 * 后去新增或者修改配置之后需要通过bus 通知服务，并且修改配置应该需要审核
 * 前期没有这个需求，不需要去做这些东西
 */
@RestController
@Api("管理系统的属性")
@RequestMapping("/v1/mgr/config/property")
class PropertyMgrController {

    @Autowired
    private lateinit var propService: IConfigPropService

    @PostMapping
    @ApiOperation("添加系统的属性")
    fun addProp(@RequestBody prop: ConfigProperty) {
        propService.addProp(prop)
    }

    @PutMapping("/{id}")
    @ApiOperation("更新系统配置信息")
    fun updateProps(@RequestBody prop: ConfigProperty,
                    @PathVariable("id") id: Int) {
        prop.id = id
        propService.updateById(prop)
    }

    @DeleteMapping("/{id}")
    @ApiOperation("删除系统配置信息")
    fun delete(@PathVariable("id") id: Int) {
        propService.deleteById(id)
    }

    @GetMapping
    @ApiOperation("条件查询系统配置信息")
    fun query(cond: ConfigProperty,
              @RequestParam("current") page: Long,
              @RequestParam("pageSize") pageSize: Long): IPage<ConfigProperty> {
        return propService.query(cond, page, pageSize)
    }
}