package cn.gygxzc.cloud.config.controller

import org.springframework.beans.factory.annotation.Autowired
import org.springframework.beans.factory.annotation.Value
import org.springframework.cloud.bus.event.RefreshRemoteApplicationEvent
import org.springframework.context.ApplicationEventPublisher
import org.springframework.web.bind.annotation.PathVariable
import org.springframework.web.bind.annotation.PostMapping
import org.springframework.web.bind.annotation.RequestMapping
import org.springframework.web.bind.annotation.RestController

/**
 * @author tuonina
 * @createTime 2019/4/16
 * 通过前端接口刷新服务的配置
 */
@RestController
@RequestMapping("/v1/refresh/config")
class RefreshConfigController {

    @Autowired
    private var applicationEventPublisher: ApplicationEventPublisher? = null

    @Value("\${spring.application.name}")
    private lateinit var busId: String


    @PostMapping("/{application}")
    fun refresh(@PathVariable("application") application: String) {
        if (this.applicationEventPublisher == null) {
            throw RuntimeException("无法发送消息！")
        }
        applicationEventPublisher!!.publishEvent(RefreshRemoteApplicationEvent(this, busId, application))
    }

}