package cn.gygxzc.cloud.config.service.impl

import cn.gygxzc.cloud.config.dao.IPropertyDao
import cn.gygxzc.cloud.config.model.ConfigProperty
import cn.gygxzc.cloud.config.service.IConfigPropService
import cn.gygxzc.tina.cloud.jwt.session.utils.SessionUtils
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper
import com.baomidou.mybatisplus.core.metadata.IPage
import com.baomidou.mybatisplus.extension.plugins.pagination.Page
import org.springframework.beans.factory.annotation.Autowired
import org.springframework.stereotype.Service
import java.util.*

/**
 * @author tuonina
 * @createTime 2019/4/12
 *
 */
@Service
class ConfigPropService : IConfigPropService {

    @Autowired
    private lateinit var propDao: IPropertyDao

    override fun addProp(prop: ConfigProperty) {
        prop.createBy = SessionUtils.getAccount()
        prop.createTime = Date()
        propDao.insert(prop)
    }

    override fun deleteById(id: Int) {
        propDao.deleteById(id)
    }

    override fun updateById(prop: ConfigProperty) {
        prop.updateBy = SessionUtils.getAccount()
        prop.updateTime = Date()
        propDao.updateById(prop)
    }

    override fun query(prop: ConfigProperty,
                       page: Long, pageSize: Long): IPage<ConfigProperty> {
        val queryWrapper = QueryWrapper<ConfigProperty>()
        queryWrapper.orderByDesc("application","profile","`key`")
        if (!prop.application.isNullOrBlank()){
            queryWrapper.eq("application",prop.application)
        }
        if (!prop.profile.isNullOrBlank()){
            queryWrapper.eq("profile",prop.profile)
        }
        if (!prop.label.isNullOrBlank()){
            queryWrapper.eq("label",prop.label)
        }
        if (!prop.key.isNullOrBlank()){
            queryWrapper.like("`key`",prop.key)
        }
        return propDao.selectPage(Page(page, pageSize), queryWrapper)
    }


}